/*---------------------------------------------------------------------------*
  Project:  NitroSDK - GX - demos - UnitTours/3D_Shadow_Pol
  File:     data.c

  Copyright 2003-2005 Nintendo. All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law. They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Log: data.c,v $
  Revision 1.4  2005/02/28 05:26:04  yosizaki
  do-indent.

  Revision 1.3  2004/04/07 01:22:56  yada
  Fixed header comment

  Revision 1.2  2004/04/06 12:48:06  yada
  Fixed header comment

  Revision 1.1  2004/03/01 09:09:37  takano_makoto
  Initial check-in.

  $NoKeywords: $
 *---------------------------------------------------------------------------*/

/*
 ******************************************************************************
 *
 *  Project    :
 *               nitroSDK sample program
 *  Title      :
 *               Use shadow polygons for shadow display  
 *  Explanation:
 *
 ******************************************************************************
 */
#include <nitro/gx/g3.h>

const u32 sphere1[] = {
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3c08486f,
    0xe1d10701, 0x0000fbf5,
    0x00086499,
    0xe1d10817, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00080400,
    0xe0c00000, 0x00000000,
    0x00086499,
    0xe1d10817, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3c08486f,
    0xe1d10701, 0x0000fbf5,
    0x383910db,
    0xe4f00d88, 0x0000f830,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x383910db,
    0xe4f00d88, 0x0000f830,
    0x34ca6139,
    0xe9e71323, 0x0000f4f4,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000a5d69,
    0xe9e71619, 0x00000000,
    0x000a5d69,
    0xe9e71619, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x34ca6139,
    0xe9e71323, 0x0000f4f4,
    0x325bf97e,
    0xf0601770, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x325bf97e,
    0xf0601770, 0x0000f278,
    0x30cdf1ac,
    0xf7e91a24, 0x0000f0e8,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000deded,
    0xf7e91e2f, 0x00000000,
    0x000deded,
    0xf7e91e2f, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x30cdf1ac,
    0xf7e91a24, 0x0000f0e8,
    0x2ff001b9,
    0x00001b10, 0x0000f060,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2ff001b9,
    0x00001b10, 0x0000f060,
    0x30c211ac,
    0x08171a24, 0x0000f0e8,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000215ed,
    0x08171e2f, 0x00000000,
    0x000215ed,
    0x08171e2f, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x30c211ac,
    0x08171a24, 0x0000f0e8,
    0x3254097e,
    0x0fa01770, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3254097e,
    0x0fa01770, 0x0000f278,
    0x34c5a139,
    0x16191323, 0x0000f4f4,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0005a569,
    0x16191619, 0x00000000,
    0x0005a569,
    0x16191619, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x34c5a139,
    0x16191323, 0x0000f4f4,
    0x3836f0db,
    0x1b100d88, 0x0000f830,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3836f0db,
    0x1b100d88, 0x0000f830,
    0x3c07b86f,
    0x1e2f0701, 0x0000fbf5,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00079c99,
    0x1e2f0817, 0x00000000,
    0x00079c99,
    0x1e2f0817, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3c07b86f,
    0x1e2f0701, 0x0000fbf5,
    0x0007fc00,
    0x1f400000, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x37c8644c,
    0xe1d1040b, 0x0000f8ff,
    0x3c08486f,
    0xe1d10701, 0x0000fbf5,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00080400,
    0xe0c00000, 0x00000000,
    0x37c8644c,
    0xe1d1040b, 0x0000f8ff,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3259107d,
    0xe4f007d0, 0x0000f278,
    0x383910db,
    0xe4f00d88, 0x0000f830,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x383910db,
    0xe4f00d88, 0x0000f830,
    0x3259107d,
    0xe4f007d0, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2c7a60b4,
    0xe9e70b0c, 0x0000ecdd,
    0x2c7a60b4,
    0xe9e70b0c, 0x0000ecdd,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x282bf8db,
    0xf0600d88, 0x0000e890,
    0x325bf97e,
    0xf0601770, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x325bf97e,
    0xf0601770, 0x0000f278,
    0x282bf8db,
    0xf0600d88, 0x0000e890,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x254df0f4,
    0xf7e90f18, 0x0000e5dc,
    0x254df0f4,
    0xf7e90f18, 0x0000e5dc,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x245000fd,
    0x00000fa0, 0x0000e4f0,
    0x2ff001b9,
    0x00001b10, 0x0000f060,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2ff001b9,
    0x00001b10, 0x0000f060,
    0x245000fd,
    0x00000fa0, 0x0000e4f0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x254210f4,
    0x08170f18, 0x0000e5dc,
    0x254210f4,
    0x08170f18, 0x0000e5dc,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x282408db,
    0x0fa00d88, 0x0000e890,
    0x3254097e,
    0x0fa01770, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3254097e,
    0x0fa01770, 0x0000f278,
    0x282408db,
    0x0fa00d88, 0x0000e890,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2c75a0b4,
    0x16190b0c, 0x0000ecdd,
    0x2c75a0b4,
    0x16190b0c, 0x0000ecdd,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3256f07d,
    0x1b1007d0, 0x0000f278,
    0x3836f0db,
    0x1b100d88, 0x0000f830,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3836f0db,
    0x1b100d88, 0x0000f830,
    0x3256f07d,
    0x1b1007d0, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x37c79c4c,
    0x1e2f040b, 0x0000f8ff,
    0x3c07b86f,
    0x1e2f0701, 0x0000fbf5,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x37c79c4c,
    0x1e2f040b, 0x0000f8ff,
    0x0007fc00,
    0x1f400000, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x37b84c00,
    0xe1d10000, 0x0000f7e9,
    0x37c8644c,
    0xe1d1040b, 0x0000f8ff,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00080400,
    0xe0c00000, 0x00000000,
    0x37c8644c,
    0xe1d1040b, 0x0000f8ff,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x37b84c00,
    0xe1d10000, 0x0000f7e9,
    0x30391400,
    0xe4f00000, 0x0000f060,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x30391400,
    0xe4f00000, 0x0000f060,
    0x297a5c00,
    0xe9e70000, 0x0000e9e7,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2c7a60b4,
    0xe9e70b0c, 0x0000ecdd,
    0x2c7a60b4,
    0xe9e70b0c, 0x0000ecdd,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x297a5c00,
    0xe9e70000, 0x0000e9e7,
    0x247bfc00,
    0xf0600000, 0x0000e4f0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x247bfc00,
    0xf0600000, 0x0000e4f0,
    0x213dec00,
    0xf7e90000, 0x0000e1d1,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x254df0f4,
    0xf7e90f18, 0x0000e5dc,
    0x254df0f4,
    0xf7e90f18, 0x0000e5dc,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x213dec00,
    0xf7e90000, 0x0000e1d1,
    0x20100000,
    0x00000000, 0x0000e0c0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x20100000,
    0x00000000, 0x0000e0c0,
    0x21321400,
    0x08170000, 0x0000e1d1,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x254210f4,
    0x08170f18, 0x0000e5dc,
    0x254210f4,
    0x08170f18, 0x0000e5dc,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x21321400,
    0x08170000, 0x0000e1d1,
    0x24740400,
    0x0fa00000, 0x0000e4f0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x24740400,
    0x0fa00000, 0x0000e4f0,
    0x2975a400,
    0x16190000, 0x0000e9e7,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2c75a0b4,
    0x16190b0c, 0x0000ecdd,
    0x2c75a0b4,
    0x16190b0c, 0x0000ecdd,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2975a400,
    0x16190000, 0x0000e9e7,
    0x3036ec00,
    0x1b100000, 0x0000f060,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3036ec00,
    0x1b100000, 0x0000f060,
    0x37b7b400,
    0x1e2f0000, 0x0000f7e9,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x37c79c4c,
    0x1e2f040b, 0x0000f8ff,
    0x37c79c4c,
    0x1e2f040b, 0x0000f8ff,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x37b7b400,
    0x1e2f0000, 0x0000f7e9,
    0x0007fc00,
    0x1f400000, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x37c867b4,
    0xe1d1fbf5, 0x0000f8ff,
    0x37b84c00,
    0xe1d10000, 0x0000f7e9,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00080400,
    0xe0c00000, 0x00000000,
    0x37c867b4,
    0xe1d1fbf5, 0x0000f8ff,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x32591383,
    0xe4f0f830, 0x0000f278,
    0x30391400,
    0xe4f00000, 0x0000f060,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x30391400,
    0xe4f00000, 0x0000f060,
    0x32591383,
    0xe4f0f830, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2c7a634c,
    0xe9e7f4f4, 0x0000ecdd,
    0x2c7a634c,
    0xe9e7f4f4, 0x0000ecdd,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x282bfb25,
    0xf060f278, 0x0000e890,
    0x247bfc00,
    0xf0600000, 0x0000e4f0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x247bfc00,
    0xf0600000, 0x0000e4f0,
    0x282bfb25,
    0xf060f278, 0x0000e890,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x254df30c,
    0xf7e9f0e8, 0x0000e5dc,
    0x254df30c,
    0xf7e9f0e8, 0x0000e5dc,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x24500303,
    0x0000f060, 0x0000e4f0,
    0x20100000,
    0x00000000, 0x0000e0c0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x20100000,
    0x00000000, 0x0000e0c0,
    0x24500303,
    0x0000f060, 0x0000e4f0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2542130c,
    0x0817f0e8, 0x0000e5dc,
    0x2542130c,
    0x0817f0e8, 0x0000e5dc,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x28240b25,
    0x0fa0f278, 0x0000e890,
    0x24740400,
    0x0fa00000, 0x0000e4f0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x24740400,
    0x0fa00000, 0x0000e4f0,
    0x28240b25,
    0x0fa0f278, 0x0000e890,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2c75a34c,
    0x1619f4f4, 0x0000ecdd,
    0x2c75a34c,
    0x1619f4f4, 0x0000ecdd,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3256f383,
    0x1b10f830, 0x0000f278,
    0x3036ec00,
    0x1b100000, 0x0000f060,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3036ec00,
    0x1b100000, 0x0000f060,
    0x3256f383,
    0x1b10f830, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x37c79fb4,
    0x1e2ffbf5, 0x0000f8ff,
    0x37b7b400,
    0x1e2f0000, 0x0000f7e9,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x37c79fb4,
    0x1e2ffbf5, 0x0000f8ff,
    0x0007fc00,
    0x1f400000, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3c084b91,
    0xe1d1f8ff, 0x0000fbf5,
    0x37c867b4,
    0xe1d1fbf5, 0x0000f8ff,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00080400,
    0xe0c00000, 0x00000000,
    0x37c867b4,
    0xe1d1fbf5, 0x0000f8ff,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3c084b91,
    0xe1d1f8ff, 0x0000fbf5,
    0x38391325,
    0xe4f0f278, 0x0000f830,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x38391325,
    0xe4f0f278, 0x0000f830,
    0x34ca62c7,
    0xe9e7ecdd, 0x0000f4f4,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2c7a634c,
    0xe9e7f4f4, 0x0000ecdd,
    0x2c7a634c,
    0xe9e7f4f4, 0x0000ecdd,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x34ca62c7,
    0xe9e7ecdd, 0x0000f4f4,
    0x325bfa82,
    0xf060e890, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x325bfa82,
    0xf060e890, 0x0000f278,
    0x30cdf254,
    0xf7e9e5dc, 0x0000f0e8,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x254df30c,
    0xf7e9f0e8, 0x0000e5dc,
    0x254df30c,
    0xf7e9f0e8, 0x0000e5dc,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x30cdf254,
    0xf7e9e5dc, 0x0000f0e8,
    0x2ff00247,
    0x0000e4f0, 0x0000f060,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2ff00247,
    0x0000e4f0, 0x0000f060,
    0x30c21254,
    0x0817e5dc, 0x0000f0e8,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2542130c,
    0x0817f0e8, 0x0000e5dc,
    0x2542130c,
    0x0817f0e8, 0x0000e5dc,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x30c21254,
    0x0817e5dc, 0x0000f0e8,
    0x32540a82,
    0x0fa0e890, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x32540a82,
    0x0fa0e890, 0x0000f278,
    0x34c5a2c7,
    0x1619ecdd, 0x0000f4f4,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2c75a34c,
    0x1619f4f4, 0x0000ecdd,
    0x2c75a34c,
    0x1619f4f4, 0x0000ecdd,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x34c5a2c7,
    0x1619ecdd, 0x0000f4f4,
    0x3836f325,
    0x1b10f278, 0x0000f830,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3836f325,
    0x1b10f278, 0x0000f830,
    0x3c07bb91,
    0x1e2ff8ff, 0x0000fbf5,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x37c79fb4,
    0x1e2ffbf5, 0x0000f8ff,
    0x37c79fb4,
    0x1e2ffbf5, 0x0000f8ff,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3c07bb91,
    0x1e2ff8ff, 0x0000fbf5,
    0x0007fc00,
    0x1f400000, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00086767,
    0xe1d1f7e9, 0x00000000,
    0x3c084b91,
    0xe1d1f8ff, 0x0000fbf5,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00080400,
    0xe0c00000, 0x00000000,
    0x00086767,
    0xe1d1f7e9, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00091703,
    0xe4f0f060, 0x00000000,
    0x38391325,
    0xe4f0f278, 0x0000f830,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x38391325,
    0xe4f0f278, 0x0000f830,
    0x00091703,
    0xe4f0f060, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000a5e97,
    0xe9e7e9e7, 0x00000000,
    0x000a5e97,
    0xe9e7e9e7, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000bfe47,
    0xf060e4f0, 0x00000000,
    0x325bfa82,
    0xf060e890, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x325bfa82,
    0xf060e890, 0x0000f278,
    0x000bfe47,
    0xf060e4f0, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000dee13,
    0xf7e9e1d1, 0x00000000,
    0x000dee13,
    0xf7e9e1d1, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00000201,
    0x0000e0c0, 0x00000000,
    0x2ff00247,
    0x0000e4f0, 0x0000f060,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2ff00247,
    0x0000e4f0, 0x0000f060,
    0x00000201,
    0x0000e0c0, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00021613,
    0x0817e1d1, 0x00000000,
    0x00021613,
    0x0817e1d1, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00040647,
    0x0fa0e4f0, 0x00000000,
    0x32540a82,
    0x0fa0e890, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x32540a82,
    0x0fa0e890, 0x0000f278,
    0x00040647,
    0x0fa0e4f0, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0005a697,
    0x1619e9e7, 0x00000000,
    0x0005a697,
    0x1619e9e7, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0006ef03,
    0x1b10f060, 0x00000000,
    0x3836f325,
    0x1b10f278, 0x0000f830,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3836f325,
    0x1b10f278, 0x0000f830,
    0x0006ef03,
    0x1b10f060, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00079f67,
    0x1e2ff7e9, 0x00000000,
    0x3c07bb91,
    0x1e2ff8ff, 0x0000fbf5,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00079f67,
    0x1e2ff7e9, 0x00000000,
    0x0007fc00,
    0x1f400000, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x04084b91,
    0xe1d1f8ff, 0x0000040b,
    0x00086767,
    0xe1d1f7e9, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00080400,
    0xe0c00000, 0x00000000,
    0x00086767,
    0xe1d1f7e9, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x04084b91,
    0xe1d1f8ff, 0x0000040b,
    0x07d91325,
    0xe4f0f278, 0x000007d0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x07d91325,
    0xe4f0f278, 0x000007d0,
    0x0b4a62c7,
    0xe9e7ecdd, 0x00000b0c,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000a5e97,
    0xe9e7e9e7, 0x00000000,
    0x000a5e97,
    0xe9e7e9e7, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0b4a62c7,
    0xe9e7ecdd, 0x00000b0c,
    0x0dbbfa82,
    0xf060e890, 0x00000d88,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0dbbfa82,
    0xf060e890, 0x00000d88,
    0x0f4df254,
    0xf7e9e5dc, 0x00000f18,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000dee13,
    0xf7e9e1d1, 0x00000000,
    0x000dee13,
    0xf7e9e1d1, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0f4df254,
    0xf7e9e5dc, 0x00000f18,
    0x10100247,
    0x0000e4f0, 0x00000fa0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x10100247,
    0x0000e4f0, 0x00000fa0,
    0x0f421254,
    0x0817e5dc, 0x00000f18,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00021613,
    0x0817e1d1, 0x00000000,
    0x00021613,
    0x0817e1d1, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0f421254,
    0x0817e5dc, 0x00000f18,
    0x0db40a82,
    0x0fa0e890, 0x00000d88,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0db40a82,
    0x0fa0e890, 0x00000d88,
    0x0b45a2c7,
    0x1619ecdd, 0x00000b0c,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0005a697,
    0x1619e9e7, 0x00000000,
    0x0005a697,
    0x1619e9e7, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0b45a2c7,
    0x1619ecdd, 0x00000b0c,
    0x07d6f325,
    0x1b10f278, 0x000007d0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x07d6f325,
    0x1b10f278, 0x000007d0,
    0x0407bb91,
    0x1e2ff8ff, 0x0000040b,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00079f67,
    0x1e2ff7e9, 0x00000000,
    0x00079f67,
    0x1e2ff7e9, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0407bb91,
    0x1e2ff8ff, 0x0000040b,
    0x0007fc00,
    0x1f400000, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x084867b4,
    0xe1d1fbf5, 0x00000701,
    0x04084b91,
    0xe1d1f8ff, 0x0000040b,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00080400,
    0xe0c00000, 0x00000000,
    0x084867b4,
    0xe1d1fbf5, 0x00000701,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0db91383,
    0xe4f0f830, 0x00000d88,
    0x07d91325,
    0xe4f0f278, 0x000007d0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x07d91325,
    0xe4f0f278, 0x000007d0,
    0x0db91383,
    0xe4f0f830, 0x00000d88,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x139a634c,
    0xe9e7f4f4, 0x00001323,
    0x139a634c,
    0xe9e7f4f4, 0x00001323,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x17ebfb25,
    0xf060f278, 0x00001770,
    0x0dbbfa82,
    0xf060e890, 0x00000d88,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0dbbfa82,
    0xf060e890, 0x00000d88,
    0x17ebfb25,
    0xf060f278, 0x00001770,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1acdf30c,
    0xf7e9f0e8, 0x00001a24,
    0x1acdf30c,
    0xf7e9f0e8, 0x00001a24,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1bb00303,
    0x0000f060, 0x00001b10,
    0x10100247,
    0x0000e4f0, 0x00000fa0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x10100247,
    0x0000e4f0, 0x00000fa0,
    0x1bb00303,
    0x0000f060, 0x00001b10,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1ac2130c,
    0x0817f0e8, 0x00001a24,
    0x1ac2130c,
    0x0817f0e8, 0x00001a24,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x17e40b25,
    0x0fa0f278, 0x00001770,
    0x0db40a82,
    0x0fa0e890, 0x00000d88,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0db40a82,
    0x0fa0e890, 0x00000d88,
    0x17e40b25,
    0x0fa0f278, 0x00001770,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1395a34c,
    0x1619f4f4, 0x00001323,
    0x1395a34c,
    0x1619f4f4, 0x00001323,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0db6f383,
    0x1b10f830, 0x00000d88,
    0x07d6f325,
    0x1b10f278, 0x000007d0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x07d6f325,
    0x1b10f278, 0x000007d0,
    0x0db6f383,
    0x1b10f830, 0x00000d88,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x08479fb4,
    0x1e2ffbf5, 0x00000701,
    0x0407bb91,
    0x1e2ff8ff, 0x0000040b,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x08479fb4,
    0x1e2ffbf5, 0x00000701,
    0x0007fc00,
    0x1f400000, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x08584c00,
    0xe1d10000, 0x00000817,
    0x084867b4,
    0xe1d1fbf5, 0x00000701,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00080400,
    0xe0c00000, 0x00000000,
    0x084867b4,
    0xe1d1fbf5, 0x00000701,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x08584c00,
    0xe1d10000, 0x00000817,
    0x0fd91400,
    0xe4f00000, 0x00000fa0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0fd91400,
    0xe4f00000, 0x00000fa0,
    0x169a5c00,
    0xe9e70000, 0x00001619,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x139a634c,
    0xe9e7f4f4, 0x00001323,
    0x139a634c,
    0xe9e7f4f4, 0x00001323,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x169a5c00,
    0xe9e70000, 0x00001619,
    0x1b9bfc00,
    0xf0600000, 0x00001b10,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1b9bfc00,
    0xf0600000, 0x00001b10,
    0x1eddec00,
    0xf7e90000, 0x00001e2f,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1acdf30c,
    0xf7e9f0e8, 0x00001a24,
    0x1acdf30c,
    0xf7e9f0e8, 0x00001a24,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1eddec00,
    0xf7e90000, 0x00001e2f,
    0x1ff00000,
    0x00000000, 0x00001f40,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1ff00000,
    0x00000000, 0x00001f40,
    0x1ed21400,
    0x08170000, 0x00001e2f,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1ac2130c,
    0x0817f0e8, 0x00001a24,
    0x1ac2130c,
    0x0817f0e8, 0x00001a24,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1ed21400,
    0x08170000, 0x00001e2f,
    0x1b940400,
    0x0fa00000, 0x00001b10,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1b940400,
    0x0fa00000, 0x00001b10,
    0x1695a400,
    0x16190000, 0x00001619,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1395a34c,
    0x1619f4f4, 0x00001323,
    0x1395a34c,
    0x1619f4f4, 0x00001323,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1695a400,
    0x16190000, 0x00001619,
    0x0fd6ec00,
    0x1b100000, 0x00000fa0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0fd6ec00,
    0x1b100000, 0x00000fa0,
    0x0857b400,
    0x1e2f0000, 0x00000817,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x08479fb4,
    0x1e2ffbf5, 0x00000701,
    0x08479fb4,
    0x1e2ffbf5, 0x00000701,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0857b400,
    0x1e2f0000, 0x00000817,
    0x0007fc00,
    0x1f400000, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0848644c,
    0xe1d1040b, 0x00000701,
    0x08584c00,
    0xe1d10000, 0x00000817,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00080400,
    0xe0c00000, 0x00000000,
    0x0848644c,
    0xe1d1040b, 0x00000701,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0db9107d,
    0xe4f007d0, 0x00000d88,
    0x0fd91400,
    0xe4f00000, 0x00000fa0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0fd91400,
    0xe4f00000, 0x00000fa0,
    0x0db9107d,
    0xe4f007d0, 0x00000d88,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x139a60b4,
    0xe9e70b0c, 0x00001323,
    0x139a60b4,
    0xe9e70b0c, 0x00001323,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x17ebf8db,
    0xf0600d88, 0x00001770,
    0x1b9bfc00,
    0xf0600000, 0x00001b10,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1b9bfc00,
    0xf0600000, 0x00001b10,
    0x17ebf8db,
    0xf0600d88, 0x00001770,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1acdf0f4,
    0xf7e90f18, 0x00001a24,
    0x1acdf0f4,
    0xf7e90f18, 0x00001a24,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1bb000fd,
    0x00000fa0, 0x00001b10,
    0x1ff00000,
    0x00000000, 0x00001f40,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1ff00000,
    0x00000000, 0x00001f40,
    0x1bb000fd,
    0x00000fa0, 0x00001b10,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1ac210f4,
    0x08170f18, 0x00001a24,
    0x1ac210f4,
    0x08170f18, 0x00001a24,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x17e408db,
    0x0fa00d88, 0x00001770,
    0x1b940400,
    0x0fa00000, 0x00001b10,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1b940400,
    0x0fa00000, 0x00001b10,
    0x17e408db,
    0x0fa00d88, 0x00001770,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1395a0b4,
    0x16190b0c, 0x00001323,
    0x1395a0b4,
    0x16190b0c, 0x00001323,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0db6f07d,
    0x1b1007d0, 0x00000d88,
    0x0fd6ec00,
    0x1b100000, 0x00000fa0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0fd6ec00,
    0x1b100000, 0x00000fa0,
    0x0db6f07d,
    0x1b1007d0, 0x00000d88,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x08479c4c,
    0x1e2f040b, 0x00000701,
    0x0857b400,
    0x1e2f0000, 0x00000817,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x08479c4c,
    0x1e2f040b, 0x00000701,
    0x0007fc00,
    0x1f400000, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0408486f,
    0xe1d10701, 0x0000040b,
    0x0848644c,
    0xe1d1040b, 0x00000701,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00080400,
    0xe0c00000, 0x00000000,
    0x0848644c,
    0xe1d1040b, 0x00000701,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0408486f,
    0xe1d10701, 0x0000040b,
    0x07d910db,
    0xe4f00d88, 0x000007d0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x07d910db,
    0xe4f00d88, 0x000007d0,
    0x0b4a6139,
    0xe9e71323, 0x00000b0c,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x139a60b4,
    0xe9e70b0c, 0x00001323,
    0x139a60b4,
    0xe9e70b0c, 0x00001323,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0b4a6139,
    0xe9e71323, 0x00000b0c,
    0x0dbbf97e,
    0xf0601770, 0x00000d88,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0dbbf97e,
    0xf0601770, 0x00000d88,
    0x0f4df1ac,
    0xf7e91a24, 0x00000f18,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1acdf0f4,
    0xf7e90f18, 0x00001a24,
    0x1acdf0f4,
    0xf7e90f18, 0x00001a24,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0f4df1ac,
    0xf7e91a24, 0x00000f18,
    0x101001b9,
    0x00001b10, 0x00000fa0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x101001b9,
    0x00001b10, 0x00000fa0,
    0x0f4211ac,
    0x08171a24, 0x00000f18,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1ac210f4,
    0x08170f18, 0x00001a24,
    0x1ac210f4,
    0x08170f18, 0x00001a24,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0f4211ac,
    0x08171a24, 0x00000f18,
    0x0db4097e,
    0x0fa01770, 0x00000d88,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0db4097e,
    0x0fa01770, 0x00000d88,
    0x0b45a139,
    0x16191323, 0x00000b0c,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1395a0b4,
    0x16190b0c, 0x00001323,
    0x1395a0b4,
    0x16190b0c, 0x00001323,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0b45a139,
    0x16191323, 0x00000b0c,
    0x07d6f0db,
    0x1b100d88, 0x000007d0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x07d6f0db,
    0x1b100d88, 0x000007d0,
    0x0407b86f,
    0x1e2f0701, 0x0000040b,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x08479c4c,
    0x1e2f040b, 0x00000701,
    0x08479c4c,
    0x1e2f040b, 0x00000701,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0407b86f,
    0x1e2f0701, 0x0000040b,
    0x0007fc00,
    0x1f400000, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00086499,
    0xe1d10817, 0x00000000,
    0x0408486f,
    0xe1d10701, 0x0000040b,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00080400,
    0xe0c00000, 0x00000000,
    0x00086499,
    0xe1d10817, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000914fd,
    0xe4f00fa0, 0x00000000,
    0x07d910db,
    0xe4f00d88, 0x000007d0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x07d910db,
    0xe4f00d88, 0x000007d0,
    0x000914fd,
    0xe4f00fa0, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000a5d69,
    0xe9e71619, 0x00000000,
    0x000a5d69,
    0xe9e71619, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000bfdb9,
    0xf0601b10, 0x00000000,
    0x0dbbf97e,
    0xf0601770, 0x00000d88,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0dbbf97e,
    0xf0601770, 0x00000d88,
    0x000bfdb9,
    0xf0601b10, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000deded,
    0xf7e91e2f, 0x00000000,
    0x000deded,
    0xf7e91e2f, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000001ff,
    0x00001f40, 0x00000000,
    0x101001b9,
    0x00001b10, 0x00000fa0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x101001b9,
    0x00001b10, 0x00000fa0,
    0x000001ff,
    0x00001f40, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000215ed,
    0x08171e2f, 0x00000000,
    0x000215ed,
    0x08171e2f, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000405b9,
    0x0fa01b10, 0x00000000,
    0x0db4097e,
    0x0fa01770, 0x00000d88,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0db4097e,
    0x0fa01770, 0x00000d88,
    0x000405b9,
    0x0fa01b10, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0005a569,
    0x16191619, 0x00000000,
    0x0005a569,
    0x16191619, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0006ecfd,
    0x1b100fa0, 0x00000000,
    0x07d6f0db,
    0x1b100d88, 0x000007d0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x07d6f0db,
    0x1b100d88, 0x000007d0,
    0x0006ecfd,
    0x1b100fa0, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00079c99,
    0x1e2f0817, 0x00000000,
    0x0407b86f,
    0x1e2f0701, 0x0000040b,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00079c99,
    0x1e2f0817, 0x00000000,
    0x0007fc00,
    0x1f400000, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x254210f4,
    0x08170f18, 0x0000e5dc,
    0x245000fd,
    0x00000fa0, 0x0000e4f0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x20100000,
    0x00000000, 0x0000e0c0,
    0x254210f4,
    0x08170f18, 0x0000e5dc,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x30c211ac,
    0x08171a24, 0x0000f0e8,
    0x2ff001b9,
    0x00001b10, 0x0000f060,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000215ed,
    0x08171e2f, 0x00000000,
    0x000001ff,
    0x00001f40, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2ff001b9,
    0x00001b10, 0x0000f060,
    0x000215ed,
    0x08171e2f, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0f4211ac,
    0x08171a24, 0x00000f18,
    0x101001b9,
    0x00001b10, 0x00000fa0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1ac210f4,
    0x08170f18, 0x00001a24,
    0x1bb000fd,
    0x00000fa0, 0x00001b10,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x101001b9,
    0x00001b10, 0x00000fa0,
    0x1ac210f4,
    0x08170f18, 0x00001a24,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1ed21400,
    0x08170000, 0x00001e2f,
    0x1ff00000,
    0x00000000, 0x00001f40,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1ac2130c,
    0x0817f0e8, 0x00001a24,
    0x1bb00303,
    0x0000f060, 0x00001b10,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1ff00000,
    0x00000000, 0x00001f40,
    0x1ac2130c,
    0x0817f0e8, 0x00001a24,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0f421254,
    0x0817e5dc, 0x00000f18,
    0x10100247,
    0x0000e4f0, 0x00000fa0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00021613,
    0x0817e1d1, 0x00000000,
    0x00000201,
    0x0000e0c0, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x10100247,
    0x0000e4f0, 0x00000fa0,
    0x00021613,
    0x0817e1d1, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x30c21254,
    0x0817e5dc, 0x0000f0e8,
    0x2ff00247,
    0x0000e4f0, 0x0000f060,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2542130c,
    0x0817f0e8, 0x0000e5dc,
    0x24500303,
    0x0000f060, 0x0000e4f0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2ff00247,
    0x0000e4f0, 0x0000f060,
    0x2542130c,
    0x0817f0e8, 0x0000e5dc,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x21321400,
    0x08170000, 0x0000e1d1,
    0x20100000,
    0x00000000, 0x0000e0c0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x24740400,
    0x0fa00000, 0x0000e4f0,
    0x21321400,
    0x08170000, 0x0000e1d1,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2542130c,
    0x0817f0e8, 0x0000e5dc,
    0x32540a82,
    0x0fa0e890, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x28240b25,
    0x0fa0f278, 0x0000e890,
    0x2542130c,
    0x0817f0e8, 0x0000e5dc,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x32540a82,
    0x0fa0e890, 0x0000f278,
    0x30c21254,
    0x0817e5dc, 0x0000f0e8,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00021613,
    0x0817e1d1, 0x00000000,
    0x0db40a82,
    0x0fa0e890, 0x00000d88,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00040647,
    0x0fa0e4f0, 0x00000000,
    0x00021613,
    0x0817e1d1, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0db40a82,
    0x0fa0e890, 0x00000d88,
    0x0f421254,
    0x0817e5dc, 0x00000f18,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1ac2130c,
    0x0817f0e8, 0x00001a24,
    0x1b940400,
    0x0fa00000, 0x00001b10,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x17e40b25,
    0x0fa0f278, 0x00001770,
    0x1ac2130c,
    0x0817f0e8, 0x00001a24,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1b940400,
    0x0fa00000, 0x00001b10,
    0x1ed21400,
    0x08170000, 0x00001e2f,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1ac210f4,
    0x08170f18, 0x00001a24,
    0x0db4097e,
    0x0fa01770, 0x00000d88,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x17e408db,
    0x0fa00d88, 0x00001770,
    0x1ac210f4,
    0x08170f18, 0x00001a24,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0db4097e,
    0x0fa01770, 0x00000d88,
    0x0f4211ac,
    0x08171a24, 0x00000f18,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000215ed,
    0x08171e2f, 0x00000000,
    0x3254097e,
    0x0fa01770, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000405b9,
    0x0fa01b10, 0x00000000,
    0x000215ed,
    0x08171e2f, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3254097e,
    0x0fa01770, 0x0000f278,
    0x30c211ac,
    0x08171a24, 0x0000f0e8,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x254210f4,
    0x08170f18, 0x0000e5dc,
    0x24740400,
    0x0fa00000, 0x0000e4f0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x282408db,
    0x0fa00d88, 0x0000e890,
    0x254210f4,
    0x08170f18, 0x0000e5dc,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2c75a34c,
    0x1619f4f4, 0x0000ecdd,
    0x2975a400,
    0x16190000, 0x0000e9e7,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x24740400,
    0x0fa00000, 0x0000e4f0,
    0x2c75a34c,
    0x1619f4f4, 0x0000ecdd,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x28240b25,
    0x0fa0f278, 0x0000e890,
    0x32540a82,
    0x0fa0e890, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0005a697,
    0x1619e9e7, 0x00000000,
    0x34c5a2c7,
    0x1619ecdd, 0x0000f4f4,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x32540a82,
    0x0fa0e890, 0x0000f278,
    0x0005a697,
    0x1619e9e7, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00040647,
    0x0fa0e4f0, 0x00000000,
    0x0db40a82,
    0x0fa0e890, 0x00000d88,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1395a34c,
    0x1619f4f4, 0x00001323,
    0x0b45a2c7,
    0x1619ecdd, 0x00000b0c,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0db40a82,
    0x0fa0e890, 0x00000d88,
    0x1395a34c,
    0x1619f4f4, 0x00001323,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x17e40b25,
    0x0fa0f278, 0x00001770,
    0x1b940400,
    0x0fa00000, 0x00001b10,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1395a0b4,
    0x16190b0c, 0x00001323,
    0x1695a400,
    0x16190000, 0x00001619,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1b940400,
    0x0fa00000, 0x00001b10,
    0x1395a0b4,
    0x16190b0c, 0x00001323,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x17e408db,
    0x0fa00d88, 0x00001770,
    0x0db4097e,
    0x0fa01770, 0x00000d88,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0005a569,
    0x16191619, 0x00000000,
    0x0b45a139,
    0x16191323, 0x00000b0c,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0db4097e,
    0x0fa01770, 0x00000d88,
    0x0005a569,
    0x16191619, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000405b9,
    0x0fa01b10, 0x00000000,
    0x3254097e,
    0x0fa01770, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2c75a0b4,
    0x16190b0c, 0x0000ecdd,
    0x34c5a139,
    0x16191323, 0x0000f4f4,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3254097e,
    0x0fa01770, 0x0000f278,
    0x2c75a0b4,
    0x16190b0c, 0x0000ecdd,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x282408db,
    0x0fa00d88, 0x0000e890,
    0x24740400,
    0x0fa00000, 0x0000e4f0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3836f325,
    0x1b10f278, 0x0000f830,
    0x3256f383,
    0x1b10f830, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2c75a34c,
    0x1619f4f4, 0x0000ecdd,
    0x3836f325,
    0x1b10f278, 0x0000f830,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x34c5a2c7,
    0x1619ecdd, 0x0000f4f4,
    0x0005a697,
    0x1619e9e7, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x07d6f325,
    0x1b10f278, 0x000007d0,
    0x0006ef03,
    0x1b10f060, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0005a697,
    0x1619e9e7, 0x00000000,
    0x07d6f325,
    0x1b10f278, 0x000007d0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0b45a2c7,
    0x1619ecdd, 0x00000b0c,
    0x1395a34c,
    0x1619f4f4, 0x00001323,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0fd6ec00,
    0x1b100000, 0x00000fa0,
    0x0db6f383,
    0x1b10f830, 0x00000d88,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1395a34c,
    0x1619f4f4, 0x00001323,
    0x0fd6ec00,
    0x1b100000, 0x00000fa0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1695a400,
    0x16190000, 0x00001619,
    0x1395a0b4,
    0x16190b0c, 0x00001323,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x07d6f0db,
    0x1b100d88, 0x000007d0,
    0x0db6f07d,
    0x1b1007d0, 0x00000d88,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1395a0b4,
    0x16190b0c, 0x00001323,
    0x07d6f0db,
    0x1b100d88, 0x000007d0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0b45a139,
    0x16191323, 0x00000b0c,
    0x0005a569,
    0x16191619, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3836f0db,
    0x1b100d88, 0x0000f830,
    0x0006ecfd,
    0x1b100fa0, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0005a569,
    0x16191619, 0x00000000,
    0x3836f0db,
    0x1b100d88, 0x0000f830,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x34c5a139,
    0x16191323, 0x0000f4f4,
    0x2c75a0b4,
    0x16190b0c, 0x0000ecdd,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3036ec00,
    0x1b100000, 0x0000f060,
    0x3256f07d,
    0x1b1007d0, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2c75a0b4,
    0x16190b0c, 0x0000ecdd,
    0x3036ec00,
    0x1b100000, 0x0000f060,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2975a400,
    0x16190000, 0x0000e9e7,
    0x2c75a34c,
    0x1619f4f4, 0x0000ecdd,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x37c79fb4,
    0x1e2ffbf5, 0x0000f8ff,
    0x37b7b400,
    0x1e2f0000, 0x0000f7e9,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3036ec00,
    0x1b100000, 0x0000f060,
    0x37c79fb4,
    0x1e2ffbf5, 0x0000f8ff,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3256f383,
    0x1b10f830, 0x0000f278,
    0x3836f325,
    0x1b10f278, 0x0000f830,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00079f67,
    0x1e2ff7e9, 0x00000000,
    0x3c07bb91,
    0x1e2ff8ff, 0x0000fbf5,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3836f325,
    0x1b10f278, 0x0000f830,
    0x00079f67,
    0x1e2ff7e9, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0006ef03,
    0x1b10f060, 0x00000000,
    0x07d6f325,
    0x1b10f278, 0x000007d0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x08479fb4,
    0x1e2ffbf5, 0x00000701,
    0x0407bb91,
    0x1e2ff8ff, 0x0000040b,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x07d6f325,
    0x1b10f278, 0x000007d0,
    0x08479fb4,
    0x1e2ffbf5, 0x00000701,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0db6f383,
    0x1b10f830, 0x00000d88,
    0x0fd6ec00,
    0x1b100000, 0x00000fa0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x08479c4c,
    0x1e2f040b, 0x00000701,
    0x0857b400,
    0x1e2f0000, 0x00000817,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0fd6ec00,
    0x1b100000, 0x00000fa0,
    0x08479c4c,
    0x1e2f040b, 0x00000701,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0db6f07d,
    0x1b1007d0, 0x00000d88,
    0x07d6f0db,
    0x1b100d88, 0x000007d0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00079c99,
    0x1e2f0817, 0x00000000,
    0x0407b86f,
    0x1e2f0701, 0x0000040b,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x07d6f0db,
    0x1b100d88, 0x000007d0,
    0x00079c99,
    0x1e2f0817, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0006ecfd,
    0x1b100fa0, 0x00000000,
    0x3836f0db,
    0x1b100d88, 0x0000f830,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x37c79c4c,
    0x1e2f040b, 0x0000f8ff,
    0x3c07b86f,
    0x1e2f0701, 0x0000fbf5,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3836f0db,
    0x1b100d88, 0x0000f830,
    0x37c79c4c,
    0x1e2f040b, 0x0000f8ff,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3256f07d,
    0x1b1007d0, 0x0000f278,
    0x3036ec00,
    0x1b100000, 0x0000f060,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x20100000,
    0x00000000, 0x0000e0c0,
    0x213dec00,
    0xf7e90000, 0x0000e1d1,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x254df30c,
    0xf7e9f0e8, 0x0000e5dc,
    0x2ff00247,
    0x0000e4f0, 0x0000f060,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x24500303,
    0x0000f060, 0x0000e4f0,
    0x254df30c,
    0xf7e9f0e8, 0x0000e5dc,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2ff00247,
    0x0000e4f0, 0x0000f060,
    0x30cdf254,
    0xf7e9e5dc, 0x0000f0e8,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000dee13,
    0xf7e9e1d1, 0x00000000,
    0x10100247,
    0x0000e4f0, 0x00000fa0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00000201,
    0x0000e0c0, 0x00000000,
    0x000dee13,
    0xf7e9e1d1, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x10100247,
    0x0000e4f0, 0x00000fa0,
    0x0f4df254,
    0xf7e9e5dc, 0x00000f18,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1acdf30c,
    0xf7e9f0e8, 0x00001a24,
    0x1ff00000,
    0x00000000, 0x00001f40,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1bb00303,
    0x0000f060, 0x00001b10,
    0x1acdf30c,
    0xf7e9f0e8, 0x00001a24,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1ff00000,
    0x00000000, 0x00001f40,
    0x1eddec00,
    0xf7e90000, 0x00001e2f,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1acdf0f4,
    0xf7e90f18, 0x00001a24,
    0x101001b9,
    0x00001b10, 0x00000fa0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1bb000fd,
    0x00000fa0, 0x00001b10,
    0x1acdf0f4,
    0xf7e90f18, 0x00001a24,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x101001b9,
    0x00001b10, 0x00000fa0,
    0x0f4df1ac,
    0xf7e91a24, 0x00000f18,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000deded,
    0xf7e91e2f, 0x00000000,
    0x2ff001b9,
    0x00001b10, 0x0000f060,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000001ff,
    0x00001f40, 0x00000000,
    0x000deded,
    0xf7e91e2f, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2ff001b9,
    0x00001b10, 0x0000f060,
    0x30cdf1ac,
    0xf7e91a24, 0x0000f0e8,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x254df0f4,
    0xf7e90f18, 0x0000e5dc,
    0x20100000,
    0x00000000, 0x0000e0c0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x245000fd,
    0x00000fa0, 0x0000e4f0,
    0x254df0f4,
    0xf7e90f18, 0x0000e5dc,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x254df30c,
    0xf7e9f0e8, 0x0000e5dc,
    0x282bfb25,
    0xf060f278, 0x0000e890,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x325bfa82,
    0xf060e890, 0x0000f278,
    0x000dee13,
    0xf7e9e1d1, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x30cdf254,
    0xf7e9e5dc, 0x0000f0e8,
    0x325bfa82,
    0xf060e890, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000dee13,
    0xf7e9e1d1, 0x00000000,
    0x000bfe47,
    0xf060e4f0, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0dbbfa82,
    0xf060e890, 0x00000d88,
    0x1acdf30c,
    0xf7e9f0e8, 0x00001a24,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0f4df254,
    0xf7e9e5dc, 0x00000f18,
    0x0dbbfa82,
    0xf060e890, 0x00000d88,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1acdf30c,
    0xf7e9f0e8, 0x00001a24,
    0x17ebfb25,
    0xf060f278, 0x00001770,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1b9bfc00,
    0xf0600000, 0x00001b10,
    0x1acdf0f4,
    0xf7e90f18, 0x00001a24,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1eddec00,
    0xf7e90000, 0x00001e2f,
    0x1b9bfc00,
    0xf0600000, 0x00001b10,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1acdf0f4,
    0xf7e90f18, 0x00001a24,
    0x17ebf8db,
    0xf0600d88, 0x00001770,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0dbbf97e,
    0xf0601770, 0x00000d88,
    0x000deded,
    0xf7e91e2f, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0f4df1ac,
    0xf7e91a24, 0x00000f18,
    0x0dbbf97e,
    0xf0601770, 0x00000d88,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000deded,
    0xf7e91e2f, 0x00000000,
    0x000bfdb9,
    0xf0601b10, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x325bf97e,
    0xf0601770, 0x0000f278,
    0x254df0f4,
    0xf7e90f18, 0x0000e5dc,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x30cdf1ac,
    0xf7e91a24, 0x0000f0e8,
    0x325bf97e,
    0xf0601770, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1b9bfc00,
    0xf0600000, 0x00001b10,
    0x17ebfb25,
    0xf060f278, 0x00001770,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x139a634c,
    0xe9e7f4f4, 0x00001323,
    0x254df0f4,
    0xf7e90f18, 0x0000e5dc,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x282bf8db,
    0xf0600d88, 0x0000e890,
    0x247bfc00,
    0xf0600000, 0x0000e4f0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x254df30c,
    0xf7e9f0e8, 0x0000e5dc,
    0x213dec00,
    0xf7e90000, 0x0000e1d1,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x247bfc00,
    0xf0600000, 0x0000e4f0,
    0x325bf97e,
    0xf0601770, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x34ca6139,
    0xe9e71323, 0x0000f4f4,
    0x2c7a60b4,
    0xe9e70b0c, 0x0000ecdd,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x247bfc00,
    0xf0600000, 0x0000e4f0,
    0x282bf8db,
    0xf0600d88, 0x0000e890,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2c7a60b4,
    0xe9e70b0c, 0x0000ecdd,
    0x247bfc00,
    0xf0600000, 0x0000e4f0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x297a5c00,
    0xe9e70000, 0x0000e9e7,
    0x2c7a634c,
    0xe9e7f4f4, 0x0000ecdd,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x325bfa82,
    0xf060e890, 0x0000f278,
    0x282bfb25,
    0xf060f278, 0x0000e890,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2c7a634c,
    0xe9e7f4f4, 0x0000ecdd,
    0x325bfa82,
    0xf060e890, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x34ca62c7,
    0xe9e7ecdd, 0x0000f4f4,
    0x000a5e97,
    0xe9e7e9e7, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0dbbfa82,
    0xf060e890, 0x00000d88,
    0x000bfe47,
    0xf060e4f0, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000a5e97,
    0xe9e7e9e7, 0x00000000,
    0x0dbbfa82,
    0xf060e890, 0x00000d88,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0b4a62c7,
    0xe9e7ecdd, 0x00000b0c,
    0x139a634c,
    0xe9e7f4f4, 0x00001323,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x1b9bfc00,
    0xf0600000, 0x00001b10,
    0x169a5c00,
    0xe9e70000, 0x00001619,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x139a60b4,
    0xe9e70b0c, 0x00001323,
    0x0dbbf97e,
    0xf0601770, 0x00000d88,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x17ebf8db,
    0xf0600d88, 0x00001770,
    0x139a60b4,
    0xe9e70b0c, 0x00001323,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0dbbf97e,
    0xf0601770, 0x00000d88,
    0x0b4a6139,
    0xe9e71323, 0x00000b0c,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000a5d69,
    0xe9e71619, 0x00000000,
    0x325bf97e,
    0xf0601770, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000bfdb9,
    0xf0601b10, 0x00000000,
    0x000a5d69,
    0xe9e71619, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2c7a634c,
    0xe9e7f4f4, 0x0000ecdd,
    0x32591383,
    0xe4f0f830, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x38391325,
    0xe4f0f278, 0x0000f830,
    0x000a5e97,
    0xe9e7e9e7, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x34ca62c7,
    0xe9e7ecdd, 0x0000f4f4,
    0x38391325,
    0xe4f0f278, 0x0000f830,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000a5e97,
    0xe9e7e9e7, 0x00000000,
    0x00091703,
    0xe4f0f060, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x07d91325,
    0xe4f0f278, 0x000007d0,
    0x139a634c,
    0xe9e7f4f4, 0x00001323,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0b4a62c7,
    0xe9e7ecdd, 0x00000b0c,
    0x07d91325,
    0xe4f0f278, 0x000007d0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x139a634c,
    0xe9e7f4f4, 0x00001323,
    0x0db91383,
    0xe4f0f830, 0x00000d88,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0fd91400,
    0xe4f00000, 0x00000fa0,
    0x139a60b4,
    0xe9e70b0c, 0x00001323,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x169a5c00,
    0xe9e70000, 0x00001619,
    0x0fd91400,
    0xe4f00000, 0x00000fa0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x139a60b4,
    0xe9e70b0c, 0x00001323,
    0x0db9107d,
    0xe4f007d0, 0x00000d88,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x07d910db,
    0xe4f00d88, 0x000007d0,
    0x000a5d69,
    0xe9e71619, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0b4a6139,
    0xe9e71323, 0x00000b0c,
    0x07d910db,
    0xe4f00d88, 0x000007d0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000a5d69,
    0xe9e71619, 0x00000000,
    0x000914fd,
    0xe4f00fa0, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x383910db,
    0xe4f00d88, 0x0000f830,
    0x2c7a60b4,
    0xe9e70b0c, 0x0000ecdd,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x34ca6139,
    0xe9e71323, 0x0000f4f4,
    0x383910db,
    0xe4f00d88, 0x0000f830,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x2c7a60b4,
    0xe9e70b0c, 0x0000ecdd,
    0x3259107d,
    0xe4f007d0, 0x0000f278,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x30391400,
    0xe4f00000, 0x0000f060,
    0x2c7a634c,
    0xe9e7f4f4, 0x0000ecdd,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x297a5c00,
    0xe9e70000, 0x0000e9e7,
    0x30391400,
    0xe4f00000, 0x0000f060,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x38391325,
    0xe4f0f278, 0x0000f830,
    0x3c084b91,
    0xe1d1f8ff, 0x0000fbf5,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00086767,
    0xe1d1f7e9, 0x00000000,
    0x07d91325,
    0xe4f0f278, 0x000007d0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00091703,
    0xe4f0f060, 0x00000000,
    0x00086767,
    0xe1d1f7e9, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x07d91325,
    0xe4f0f278, 0x000007d0,
    0x04084b91,
    0xe1d1f8ff, 0x0000040b,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x084867b4,
    0xe1d1fbf5, 0x00000701,
    0x0fd91400,
    0xe4f00000, 0x00000fa0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0db91383,
    0xe4f0f830, 0x00000d88,
    0x084867b4,
    0xe1d1fbf5, 0x00000701,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0fd91400,
    0xe4f00000, 0x00000fa0,
    0x08584c00,
    0xe1d10000, 0x00000817,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0848644c,
    0xe1d1040b, 0x00000701,
    0x07d910db,
    0xe4f00d88, 0x000007d0,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x0db9107d,
    0xe4f007d0, 0x00000d88,
    0x0848644c,
    0xe1d1040b, 0x00000701,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x07d910db,
    0xe4f00d88, 0x000007d0,
    0x0408486f,
    0xe1d10701, 0x0000040b,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x00086499,
    0xe1d10817, 0x00000000,
    0x383910db,
    0xe4f00d88, 0x0000f830,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x000914fd,
    0xe4f00fa0, 0x00000000,
    0x00086499,
    0xe1d10817, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x383910db,
    0xe4f00d88, 0x0000f830,
    0x3c08486f,
    0xe1d10701, 0x0000fbf5,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x37c8644c,
    0xe1d1040b, 0x0000f8ff,
    0x30391400,
    0xe4f00000, 0x0000f060,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x3259107d,
    0xe4f007d0, 0x0000f278,
    0x37c8644c,
    0xe1d1040b, 0x0000f8ff,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x30391400,
    0xe4f00000, 0x0000f060,
    0x37b84c00,
    0xe1d10000, 0x0000f7e9,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x37c867b4,
    0xe1d1fbf5, 0x0000f8ff,
    0x38391325,
    0xe4f0f278, 0x0000f830,
    (G3OP_VTX_16 << 24) | (G3OP_NORMAL << 16) | (G3OP_VTX_16 << 8) | (G3OP_NORMAL),
    0x32591383,
    0xe4f0f830, 0x0000f278,
    0x37c867b4,
    0xe1d1fbf5, 0x0000f8ff,
};

const u32 cylinder1[] = {
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0xb1e01b10, 0x0000f060,
    0xb1e01f40, 0x00000000,
    0xb1e00000, 0x00000000,
    0xb1e01f40, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0xb1e01b10, 0x0000f060,
    0x4e201b10, 0x0000f060,
    0x4e201f40, 0x00000000,
    0x4e201b10, 0x0000f060,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0x4e200000, 0x00000000,
    0xb1e00fa0, 0x0000e4f0,
    0xb1e01b10, 0x0000f060,
    0xb1e00000, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0xb1e00fa0, 0x0000e4f0,
    0x4e200fa0, 0x0000e4f0,
    0x4e201b10, 0x0000f060,
    0x4e201b10, 0x0000f060,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0x4e200fa0, 0x0000e4f0,
    0x4e200000, 0x00000000,
    0xb1e00000, 0x0000e0c0,
    0xb1e00fa0, 0x0000e4f0,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0xb1e00000, 0x00000000,
    0xb1e00fa0, 0x0000e4f0,
    0xb1e00000, 0x0000e0c0,
    0x4e200000, 0x0000e0c0,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0x4e200fa0, 0x0000e4f0,
    0x4e200000, 0x0000e0c0,
    0x4e200000, 0x00000000,
    0xb1e0f060, 0x0000e4f0,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0xb1e00000, 0x0000e0c0,
    0xb1e00000, 0x00000000,
    0xb1e0f060, 0x0000e4f0,
    0x4e20f060, 0x0000e4f0,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0x4e200000, 0x0000e0c0,
    0x4e200000, 0x0000e0c0,
    0x4e20f060, 0x0000e4f0,
    0x4e200000, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0xb1e0e4f0, 0x0000f060,
    0xb1e0f060, 0x0000e4f0,
    0xb1e00000, 0x00000000,
    0xb1e0f060, 0x0000e4f0,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0xb1e0e4f0, 0x0000f060,
    0x4e20e4f0, 0x0000f060,
    0x4e20f060, 0x0000e4f0,
    0x4e20e4f0, 0x0000f060,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0x4e200000, 0x00000000,
    0xb1e0e0c0, 0x00000000,
    0xb1e0e4f0, 0x0000f060,
    0xb1e00000, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0xb1e0e0c0, 0x00000000,
    0x4e20e0c0, 0x00000000,
    0x4e20e4f0, 0x0000f060,
    0x4e20e4f0, 0x0000f060,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0x4e20e0c0, 0x00000000,
    0x4e200000, 0x00000000,
    0xb1e0e4f0, 0x00000fa0,
    0xb1e0e0c0, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0xb1e00000, 0x00000000,
    0xb1e0e0c0, 0x00000000,
    0xb1e0e4f0, 0x00000fa0,
    0x4e20e4f0, 0x00000fa0,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0x4e20e0c0, 0x00000000,
    0x4e20e4f0, 0x00000fa0,
    0x4e200000, 0x00000000,
    0xb1e0f060, 0x00001b10,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0xb1e0e4f0, 0x00000fa0,
    0xb1e00000, 0x00000000,
    0xb1e0f060, 0x00001b10,
    0x4e20f060, 0x00001b10,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0x4e20e4f0, 0x00000fa0,
    0x4e20e4f0, 0x00000fa0,
    0x4e20f060, 0x00001b10,
    0x4e200000, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0xb1e00000, 0x00001f40,
    0xb1e0f060, 0x00001b10,
    0xb1e00000, 0x00000000,
    0xb1e0f060, 0x00001b10,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0xb1e00000, 0x00001f40,
    0x4e200000, 0x00001f40,
    0x4e20f060, 0x00001b10,
    0x4e200000, 0x00001f40,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0x4e200000, 0x00000000,
    0xb1e00fa0, 0x00001b10,
    0xb1e00000, 0x00001f40,
    0xb1e00000, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0xb1e00fa0, 0x00001b10,
    0x4e200fa0, 0x00001b10,
    0x4e200000, 0x00001f40,
    0x4e200000, 0x00001f40,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0x4e200fa0, 0x00001b10,
    0x4e200000, 0x00000000,
    0xb1e01b10, 0x00000fa0,
    0xb1e00fa0, 0x00001b10,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0xb1e00000, 0x00000000,
    0xb1e00fa0, 0x00001b10,
    0xb1e01b10, 0x00000fa0,
    0x4e201b10, 0x00000fa0,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0xb1e00fa0, 0x00001b10,
    0x4e201b10, 0x00000fa0,
    0x4e200fa0, 0x00001b10,
    0x4e200fa0, 0x00001b10,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0x4e201b10, 0x00000fa0,
    0x4e200000, 0x00000000,
    0xb1e01f40, 0x00000000,
    0xb1e01b10, 0x00000fa0,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0xb1e00000, 0x00000000,
    0xb1e01f40, 0x00000000,
    0x4e201f40, 0x00000000,
    0x4e201b10, 0x00000fa0,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0x4e201b10, 0x00000fa0,
    0x4e201f40, 0x00000000,
    0x4e200000, 0x00000000,
    0x4e201b10, 0x00000fa0,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0xb1e01b10, 0x00000fa0,
    0xb1e01f40, 0x00000000,
    0x4e201b10, 0x0000f060,
    0x4e201f40, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0xb1e01f40, 0x00000000,
    0x4e201b10, 0x0000f060,
    0xb1e01b10, 0x0000f060,
    0xb1e00fa0, 0x0000e4f0,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0x4e200000, 0x0000e0c0,
    0x4e200fa0, 0x0000e4f0,
    0xb1e00fa0, 0x0000e4f0,
    0x4e200000, 0x0000e0c0,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0xb1e00000, 0x0000e0c0,
    0xb1e0f060, 0x0000e4f0,
    0x4e20e4f0, 0x0000f060,
    0x4e20f060, 0x0000e4f0,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0xb1e0f060, 0x0000e4f0,
    0x4e20e4f0, 0x0000f060,
    0xb1e0e4f0, 0x0000f060,
    0xb1e0e0c0, 0x00000000,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0x4e20e4f0, 0x00000fa0,
    0x4e20e0c0, 0x00000000,
    0xb1e0e0c0, 0x00000000,
    0x4e20e4f0, 0x00000fa0,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0xb1e0e4f0, 0x00000fa0,
    0xb1e0f060, 0x00001b10,
    0x4e200000, 0x00001f40,
    0x4e20f060, 0x00001b10,
    (G3OP_VTX_16 << 24) | (G3OP_VTX_16 << 16) | (G3OP_VTX_16 << 8) | (G3OP_VTX_16),
    0xb1e0f060, 0x00001b10,
    0x4e200000, 0x00001f40,
    0xb1e00000, 0x00001f40,
    0xb1e00fa0, 0x00001b10,
};

const u32 sphere_size = sizeof(sphere1);
const u32 cylinder_size = sizeof(cylinder1);

